diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
index 6ee7ee0c4..e1e5fa509 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemQuiverEndless.java
@@ -1,13 +1,18 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.projectile.ProjectileArrow;
+import net.minecraft.core.entity.projectile.ProjectileArrowPurple;
 import net.minecraft.core.enums.HumanArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class ItemQuiverEndless extends Item implements IArmorItem<HumanArmorShape> {
+import java.util.Random;
+
+public class ItemQuiverEndless extends Item implements IArmorItem<HumanArmorShape>, IDispensable {
 
     public ItemQuiverEndless(@NotNull String name, @NotNull String namespaceId, int id) {
         super(name, namespaceId, id);
@@ -32,4 +37,11 @@ public class ItemQuiverEndless extends Item implements IArmorItem<HumanArmorShap
         return HumanArmorShape.CHEST;
     }
 
+    @Override
+    public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
+        final @NotNull ProjectileArrowPurple arrow = new ProjectileArrowPurple(world, x, y, z);
+        arrow.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+        arrow.setDoesArrowBelongToPlayer(true);
+        world.entityJoinedWorld(arrow);
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
index 03373e16e..3a7e3922b 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemSnowball.java
@@ -38,8 +38,10 @@ public class ItemSnowball extends Item implements IDispensable {
 
     @Override
     public void onDispensed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Random random, @NotNull Direction direction, double x, double y, double z) {
-        ProjectileSnowball snowball = new ProjectileSnowball(world, x, y, z);
-        snowball.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
-        world.entityJoinedWorld(snowball);
+        if (selfStack.consumeItem(null)) {
+            ProjectileSnowball snowball = new ProjectileSnowball(world, x, y, z);
+            snowball.setHeading(direction.getOffsetX(), direction.getOffsetY() + 0.1D, direction.getOffsetZ(), 1.1F, 6F);
+            world.entityJoinedWorld(snowball);
+        }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/Items.java b/game/core/src/main/java/net/minecraft/core/item/Items.java
index cdb68cf16..cd467accd 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Items.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Items.java
@@ -5,6 +5,7 @@ import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.enums.HumanArmorShape;
+import net.minecraft.core.enums.WolfArmorShape;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.item.tag.ItemTags;
@@ -83,6 +84,7 @@ public final class Items {
     public static Item ARMOR_CHESTPLATE_GOLD;
     public static Item ARMOR_LEGGINGS_GOLD;
     public static Item ARMOR_BOOTS_GOLD;
+
     public static Item FLINT;
     public static Item FOOD_PORKCHOP_RAW;
     public static Item FOOD_PORKCHOP_COOKED;
@@ -208,6 +210,12 @@ public final class Items {
     public static Item RUBYGLASS_DUST;
     public static Item RUBYGLASS_CRYSTAL;
 
+    public static Item ARMOR_WOLF_LEATHER;
+    public static Item ARMOR_WOLF_CHAINMAIL;
+    public static Item ARMOR_WOLF_IRON;
+    public static Item ARMOR_WOLF_DIAMOND;
+    public static Item ARMOR_WOLF_GOLD;
+    public static Item ARMOR_WOLF_STEEL;
 
     private static boolean hasInit = false;
     public static void init(){
@@ -287,30 +295,30 @@ public final class Items {
         WHEAT = (new Item("wheat", "minecraft:item/wheat", 16424)).withTags(ItemTags.COWS_FAVOURITE_ITEM);
         FOOD_BREAD = (new ItemFood("food.bread", "minecraft:item/food_bread", 16425, 5, 12, false, 8));
 
-        ARMOR_HELMET_LEATHER = (new ItemArmor("armor.helmet.leather", "minecraft:item/armor_helmet_leather", 16426, ArmorMaterial.LEATHER, HumanArmorShape.HEAD));
-        ARMOR_CHESTPLATE_LEATHER = (new ItemArmor("armor.chestplate.leather", "minecraft:item/armor_chestplate_leather", 16427, ArmorMaterial.LEATHER, HumanArmorShape.CHEST));
-        ARMOR_LEGGINGS_LEATHER = (new ItemArmor("armor.leggings.leather", "minecraft:item/armor_leggings_leather", 16428, ArmorMaterial.LEATHER, HumanArmorShape.LEGS));
-        ARMOR_BOOTS_LEATHER = (new ItemArmor("armor.boots.leather", "minecraft:item/armor_boots_leather", 16429, ArmorMaterial.LEATHER, HumanArmorShape.BOOTS));
+        ARMOR_HELMET_LEATHER = (new ItemArmor<>("armor.helmet.leather", "minecraft:item/armor_helmet_leather", 16426, ArmorMaterial.LEATHER, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_LEATHER = (new ItemArmor<>("armor.chestplate.leather", "minecraft:item/armor_chestplate_leather", 16427, ArmorMaterial.LEATHER, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_LEATHER = (new ItemArmor<>("armor.leggings.leather", "minecraft:item/armor_leggings_leather", 16428, ArmorMaterial.LEATHER, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_LEATHER = (new ItemArmor<>("armor.boots.leather", "minecraft:item/armor_boots_leather", 16429, ArmorMaterial.LEATHER, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_CHAINMAIL = (new ItemArmor("armor.helmet.chainmail", "minecraft:item/armor_helmet_chainmail", 16430, ArmorMaterial.CHAINMAIL, HumanArmorShape.HEAD));
-        ARMOR_CHESTPLATE_CHAINMAIL = (new ItemArmor("armor.chestplate.chainmail", "minecraft:item/armor_chestplate_chainmail", 16431, ArmorMaterial.CHAINMAIL, HumanArmorShape.CHEST));
-        ARMOR_LEGGINGS_CHAINMAIL = (new ItemArmor("armor.leggings.chainmail", "minecraft:item/armor_leggings_chainmail", 16432, ArmorMaterial.CHAINMAIL, HumanArmorShape.LEGS));
-        ARMOR_BOOTS_CHAINMAIL = (new ItemArmor("armor.boots.chainmail", "minecraft:item/armor_boots_chainmail", 16433, ArmorMaterial.CHAINMAIL, HumanArmorShape.BOOTS));
+        ARMOR_HELMET_CHAINMAIL = (new ItemArmor<>("armor.helmet.chainmail", "minecraft:item/armor_helmet_chainmail", 16430, ArmorMaterial.CHAINMAIL, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_CHAINMAIL = (new ItemArmor<>("armor.chestplate.chainmail", "minecraft:item/armor_chestplate_chainmail", 16431, ArmorMaterial.CHAINMAIL, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_CHAINMAIL = (new ItemArmor<>("armor.leggings.chainmail", "minecraft:item/armor_leggings_chainmail", 16432, ArmorMaterial.CHAINMAIL, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_CHAINMAIL = (new ItemArmor<>("armor.boots.chainmail", "minecraft:item/armor_boots_chainmail", 16433, ArmorMaterial.CHAINMAIL, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_IRON = (new ItemArmor("armor.helmet.iron", "minecraft:item/armor_helmet_iron", 16434, ArmorMaterial.IRON, HumanArmorShape.HEAD));
-        ARMOR_CHESTPLATE_IRON = (new ItemArmor("armor.chestplate.iron", "minecraft:item/armor_chestplate_iron", 16435, ArmorMaterial.IRON, HumanArmorShape.CHEST));
-        ARMOR_LEGGINGS_IRON = (new ItemArmor("armor.leggings.iron", "minecraft:item/armor_leggings_iron", 16436, ArmorMaterial.IRON, HumanArmorShape.LEGS));
-        ARMOR_BOOTS_IRON = (new ItemArmor("armor.boots.iron", "minecraft:item/armor_boots_iron", 16437, ArmorMaterial.IRON, HumanArmorShape.BOOTS));
+        ARMOR_HELMET_IRON = (new ItemArmor<>("armor.helmet.iron", "minecraft:item/armor_helmet_iron", 16434, ArmorMaterial.IRON, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_IRON = (new ItemArmor<>("armor.chestplate.iron", "minecraft:item/armor_chestplate_iron", 16435, ArmorMaterial.IRON, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_IRON = (new ItemArmor<>("armor.leggings.iron", "minecraft:item/armor_leggings_iron", 16436, ArmorMaterial.IRON, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_IRON = (new ItemArmor<>("armor.boots.iron", "minecraft:item/armor_boots_iron", 16437, ArmorMaterial.IRON, HumanArmorShape.BOOTS));
 
-        ARMOR_HELMET_DIAMOND = (new ItemArmor("armor.helmet.diamond", "minecraft:item/armor_helmet_diamond", 16438, ArmorMaterial.DIAMOND, HumanArmorShape.HEAD)).withTags(ItemTags.IS_FIRE_PROOF);
-        ARMOR_CHESTPLATE_DIAMOND = (new ItemArmor("armor.chestplate.diamond", "minecraft:item/armor_chestplate_diamond", 16439, ArmorMaterial.DIAMOND, HumanArmorShape.CHEST)).withTags(ItemTags.IS_FIRE_PROOF);
-        ARMOR_LEGGINGS_DIAMOND = (new ItemArmor("armor.leggings.diamond", "minecraft:item/armor_leggings_diamond", 16440, ArmorMaterial.DIAMOND, HumanArmorShape.LEGS)).withTags(ItemTags.IS_FIRE_PROOF);
-        ARMOR_BOOTS_DIAMOND = (new ItemArmor("armor.boots.diamond", "minecraft:item/armor_boots_diamond", 16441, ArmorMaterial.DIAMOND, HumanArmorShape.BOOTS)).withTags(ItemTags.IS_FIRE_PROOF);
+        ARMOR_HELMET_DIAMOND = (new ItemArmor<>("armor.helmet.diamond", "minecraft:item/armor_helmet_diamond", 16438, ArmorMaterial.DIAMOND, HumanArmorShape.HEAD)).withTags(ItemTags.IS_FIRE_PROOF);
+        ARMOR_CHESTPLATE_DIAMOND = (new ItemArmor<>("armor.chestplate.diamond", "minecraft:item/armor_chestplate_diamond", 16439, ArmorMaterial.DIAMOND, HumanArmorShape.CHEST)).withTags(ItemTags.IS_FIRE_PROOF);
+        ARMOR_LEGGINGS_DIAMOND = (new ItemArmor<>("armor.leggings.diamond", "minecraft:item/armor_leggings_diamond", 16440, ArmorMaterial.DIAMOND, HumanArmorShape.LEGS)).withTags(ItemTags.IS_FIRE_PROOF);
+        ARMOR_BOOTS_DIAMOND = (new ItemArmor<>("armor.boots.diamond", "minecraft:item/armor_boots_diamond", 16441, ArmorMaterial.DIAMOND, HumanArmorShape.BOOTS)).withTags(ItemTags.IS_FIRE_PROOF);
 
-        ARMOR_HELMET_GOLD = (new ItemArmor("armor.helmet.gold", "minecraft:item/armor_helmet_gold", 16442, ArmorMaterial.GOLD, HumanArmorShape.HEAD));
-        ARMOR_CHESTPLATE_GOLD = (new ItemArmor("armor.chestplate.gold", "minecraft:item/armor_chestplate_gold", 16443, ArmorMaterial.GOLD, HumanArmorShape.CHEST));
-        ARMOR_LEGGINGS_GOLD = (new ItemArmor("armor.leggings.gold", "minecraft:item/armor_leggings_gold", 16444, ArmorMaterial.GOLD, HumanArmorShape.LEGS));
-        ARMOR_BOOTS_GOLD = (new ItemArmor("armor.boots.gold", "minecraft:item/armor_boots_gold", 16445, ArmorMaterial.GOLD, HumanArmorShape.BOOTS));
+        ARMOR_HELMET_GOLD = (new ItemArmor<>("armor.helmet.gold", "minecraft:item/armor_helmet_gold", 16442, ArmorMaterial.GOLD, HumanArmorShape.HEAD));
+        ARMOR_CHESTPLATE_GOLD = (new ItemArmor<>("armor.chestplate.gold", "minecraft:item/armor_chestplate_gold", 16443, ArmorMaterial.GOLD, HumanArmorShape.CHEST));
+        ARMOR_LEGGINGS_GOLD = (new ItemArmor<>("armor.leggings.gold", "minecraft:item/armor_leggings_gold", 16444, ArmorMaterial.GOLD, HumanArmorShape.LEGS));
+        ARMOR_BOOTS_GOLD = (new ItemArmor<>("armor.boots.gold", "minecraft:item/armor_boots_gold", 16445, ArmorMaterial.GOLD, HumanArmorShape.BOOTS));
         FLINT = (new Item("flint", "minecraft:item/flint", 16446));
         FOOD_PORKCHOP_RAW = (new ItemFood("food.porkchop.raw", "minecraft:item/food_porkchop_raw", 16447, 3, 16, true, 4));
         FOOD_PORKCHOP_COOKED = (new ItemFood("food.porkchop.cooked", "minecraft:item/food_porkchop_cooked", 16448, 8, 16, true, 4));
@@ -366,10 +374,10 @@ public final class Items {
         RECORD_WAIT = (new ItemDiscMusic("record.wait", "minecraft:item/record_wait", 18394, "record.wait", "C418"));
         RECORD_DOG = (new ItemDiscMusic("record.dog", "minecraft:item/record_dog", 18395, "record.dog", "C418"));
         NETHERCOAL = (new Item("nethercoal", "minecraft:item/nethercoal", 16488));
-        ARMOR_HELMET_STEEL = (new ItemArmor("armor.helmet.steel", "minecraft:item/armor_helmet_steel", 16489, ArmorMaterial.STEEL, HumanArmorShape.HEAD)).withTags(ItemTags.IS_BLAST_PROOF);
-        ARMOR_CHESTPLATE_STEEL = (new ItemArmor("armor.chestplate.steel", "minecraft:item/armor_chestplate_steel", 16490, ArmorMaterial.STEEL, HumanArmorShape.CHEST)).withTags(ItemTags.IS_BLAST_PROOF);
-        ARMOR_LEGGINGS_STEEL = (new ItemArmor("armor.leggings.steel", "minecraft:item/armor_leggings_steel", 16491, ArmorMaterial.STEEL, HumanArmorShape.LEGS)).withTags(ItemTags.IS_BLAST_PROOF);
-        ARMOR_BOOTS_STEEL = (new ItemArmor("armor.boots.steel", "minecraft:item/armor_boots_steel", 16492, ArmorMaterial.STEEL, HumanArmorShape.BOOTS)).withTags(ItemTags.IS_BLAST_PROOF);
+        ARMOR_HELMET_STEEL = (new ItemArmor<>("armor.helmet.steel", "minecraft:item/armor_helmet_steel", 16489, ArmorMaterial.STEEL, HumanArmorShape.HEAD)).withTags(ItemTags.IS_BLAST_PROOF);
+        ARMOR_CHESTPLATE_STEEL = (new ItemArmor<>("armor.chestplate.steel", "minecraft:item/armor_chestplate_steel", 16490, ArmorMaterial.STEEL, HumanArmorShape.CHEST)).withTags(ItemTags.IS_BLAST_PROOF);
+        ARMOR_LEGGINGS_STEEL = (new ItemArmor<>("armor.leggings.steel", "minecraft:item/armor_leggings_steel", 16491, ArmorMaterial.STEEL, HumanArmorShape.LEGS)).withTags(ItemTags.IS_BLAST_PROOF);
+        ARMOR_BOOTS_STEEL = (new ItemArmor<>("armor.boots.steel", "minecraft:item/armor_boots_steel", 16492, ArmorMaterial.STEEL, HumanArmorShape.BOOTS)).withTags(ItemTags.IS_BLAST_PROOF);
 
         TOOL_SWORD_STEEL = (new ItemToolSword("tool.sword.steel", "minecraft:item/tool_sword_steel", 16493, ToolMaterial.steel)).withTags(ItemTags.PREVENT_CREATIVE_MINING, ItemTags.IS_BLAST_PROOF);
         TOOL_SHOVEL_STEEL = (new ItemToolShovel("tool.shovel.steel", "minecraft:item/tool_shovel_steel", 16494, ToolMaterial.steel)).withTags(ItemTags.IS_BLAST_PROOF);
@@ -435,5 +443,12 @@ public final class Items {
         WAND_NBT = new ItemWandNBT("wand.nbt", "minecraft:item/wand_nbt", 16553);
         RUBYGLASS_DUST = (new Item("rubyglass.crystal.cracked", "minecraft:item/rubyglass_crystal_cracked", 16554));
         RUBYGLASS_CRYSTAL = (new Item("rubyglass.crystal.pure", "minecraft:item/rubyglass_crystal_pure", 16555));
+
+        ARMOR_WOLF_LEATHER = new ItemArmor<>("armor.wolf.leather", "minecraft:item/armor_wolf_leather", 16556, ArmorMaterial.LEATHER, WolfArmorShape.BODY);
+        ARMOR_WOLF_CHAINMAIL = new ItemArmor<>("armor.wolf.chainmail", "minecraft:item/armor_wolf_chainmail", 16557, ArmorMaterial.CHAINMAIL, WolfArmorShape.BODY);
+        ARMOR_WOLF_IRON = new ItemArmor<>("armor.wolf.iron", "minecraft:item/armor_wolf_iron", 16558, ArmorMaterial.IRON, WolfArmorShape.BODY);
+        ARMOR_WOLF_DIAMOND = new ItemArmor<>("armor.wolf.diamond", "minecraft:item/armor_wolf_diamond", 16559, ArmorMaterial.DIAMOND, WolfArmorShape.BODY);
+        ARMOR_WOLF_GOLD = new ItemArmor<>("armor.wolf.gold", "minecraft:item/armor_wolf_gold", 16560, ArmorMaterial.GOLD, WolfArmorShape.BODY);
+        ARMOR_WOLF_STEEL = new ItemArmor<>("armor.wolf.steel", "minecraft:item/armor_wolf_steel", 16561, ArmorMaterial.STEEL, WolfArmorShape.BODY);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index e387859df..f84c19180 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1187,7 +1187,9 @@ public abstract class World implements MutableWorldSource {
                 this.updateEnoughPlayersSleepingFlag(null);
             }
 
-            this.getChunkFromChunkCoords(i, j).addEntity(entity);
+            if (!this.getChunkFromChunkCoords(i, j).addEntity(entity)) {
+                this.getChunkFromChunkCoords(i, j).addEntity(entity);
+            }
             this.entities.add(entity);
             this.obtainEntitySkin(entity);
             return true;
@@ -2269,7 +2271,7 @@ public abstract class World implements MutableWorldSource {
         int i = 0;
         for (int j = 0, entitiesSize = this.entities.size(); j < entitiesSize; j++) {
             final Entity entity = this.entities.get(j);
-            if (clazz.isAssignableFrom(entity.getClass())) {
+            if (clazz.isAssignableFrom(entity.getClass()) && !entity.isSpawnCapExempt()) {
                 i++;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
index df17a90bd..472c9b5ed 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/Chunk.java
@@ -547,13 +547,12 @@ public class Chunk {
         return this.getRawSkyLightLevel(new ChunkTilePos(x, y, z), subtractedSkyLight);
     }
 
-    public void addEntity(final @NotNull Entity entity) {
+    public boolean addEntity(final @NotNull Entity entity) {
         this.hasEntities = true;
         this.isModified = true;
         final @NotNull ChunkPos entityChunkPos = new ChunkPos(entity);
         if (!entityChunkPos.equals(this.pos)) {
-            LOGGER.warn("Wrong location! {}", entity);
-            Thread.dumpStack();
+            return false;
         }
         int section = MathHelper.clamp(MathHelper.floor(entity.y / 16D), 0, CHUNK_SECTIONS - 1);
         entity.addedToChunk = true;
@@ -561,6 +560,8 @@ public class Chunk {
         entity.chunkCoordY = section;
         entity.chunkCoordZ = this.pos.z;
         getSection(section).addEntity(entity);
+
+        return true;
     }
 
     public void removeEntity(@NotNull Entity entity) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
index 102286a8c..c02252ab1 100644
--- a/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
+++ b/game/core/src/main/java/net/minecraft/core/world/chunk/EmptyChunk.java
@@ -76,7 +76,7 @@ public class EmptyChunk extends Chunk {
     }
 
     @Override
-    public void addEntity(final @NotNull Entity entity) { }
+    public boolean addEntity(final @NotNull Entity entity) { return true; }
 
     @Override
     public void removeEntity(final @NotNull Entity entity) { }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
index 107a88dc5..7c0ea46d8 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/CavesLargeFeature.java
@@ -120,7 +120,7 @@ public class CavesLargeFeature extends LargeFeature {
             }
 
             // Check if we've hit the ocean, and if so, stop generating
-            if (world.getWorldType().getOceanBlockId() != 0) {
+            if (world.getWorldType().getOceanBlockIds()[0] != 0) {
                 boolean hasHitOcean = false;
                 for (int x = minX; !hasHitOcean && x < maxX; x++) {
                     for (int z = minZ; !hasHitOcean && z < maxZ; z++) {
@@ -130,8 +130,11 @@ public class CavesLargeFeature extends LargeFeature {
                             if (y < this.minY || y >= this.maxY) {
                                 continue;
                             }
-                            if (blockId == world.getWorldType().getOceanBlockId()) {
-                                hasHitOcean = true;
+                            for (int id : world.getWorldType().getOceanBlockIds()) {
+                                if (blockId == id) {
+                                    hasHitOcean = true;
+                                    break;
+                                }
                             }
                             if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
                                 y = minY;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
index 06cabca62..e348ee30b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/RetroCavesLargeFeature.java
@@ -119,7 +119,7 @@ public class RetroCavesLargeFeature extends LargeFeature {
             }
 
             // Check if we've hit the ocean, and if so, stop generating
-            if (world.getWorldType().getOceanBlockId() != 0) {
+            if (world.getWorldType().getOceanBlockIds().length != 0) {
                 boolean hasHitOcean = false;
                 for (int x = minX; !hasHitOcean && x < maxX; x++) {
                     for (int z = minZ; !hasHitOcean && z < maxZ; z++) {
@@ -129,8 +129,11 @@ public class RetroCavesLargeFeature extends LargeFeature {
                             if (y < this.minY || y >= this.maxY) {
                                 continue;
                             }
-                            if (blockId == world.getWorldType().getOceanBlockId()) {
-                                hasHitOcean = true;
+                            for (int id : world.getWorldType().getOceanBlockIds()) {
+                                if (blockId == id) {
+                                    hasHitOcean = true;
+                                    break;
+                                }
                             }
                             if (y != minY - 1 && x != minX && x != maxX - 1 && z != minZ && z != maxZ - 1) {
                                 y = minY;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
index 0d102f7c5..59ee6e7f5 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/classic/ChunkGeneratorClassic.java
@@ -127,7 +127,7 @@ public class ChunkGeneratorClassic
                     if (y < newHeight) {
                         blockID = this.world.getWorldType().getFillerBlockId();
                     } else if (y < this.world.getWorldType().getOceanY()) {
-                        blockID = this.world.getWorldType().getOceanBlockId();
+                        blockID = this.world.getWorldType().getOceanBlockIds()[0];
                     }
 
                     if (y == 0) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
index 9090cd118..cc925031c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/SurfaceGeneratorNether.java
@@ -40,7 +40,7 @@ public class SurfaceGeneratorNether
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
-        int oceanBlock = this.world.getWorldType().getOceanBlockId();
+        int oceanBlock = this.world.getWorldType().getOceanBlockIds()[0];
         int worldFillBlock = this.world.getWorldType().getFillerBlockId();
 
         Random rand = new Random((long) chunkX * 0x4F9939F508L + (long) chunkZ * 0x1EF1565BD5L);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
index 95e4720c9..97317851a 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/SurfaceGeneratorOverworld.java
@@ -58,7 +58,7 @@ public class SurfaceGeneratorOverworld
         int chunkX = chunk.pos.x;
         int chunkZ = chunk.pos.z;
 
-        int oceanBlock = world.getWorldType().getOceanBlockId();
+        int oceanBlock = world.getWorldType().getOceanBlockIds()[0];
         int worldFillBlock = world.getWorldType().getFillerBlockId();
 
         Random rand = new Random((long) chunkX * 0x4F9939F508L + (long) chunkZ * 0x1EF1565BD5L);
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
index 8838e954b..4d7d5bf1d 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/TerrainGeneratorOverworld.java
@@ -47,7 +47,7 @@ public class TerrainGeneratorOverworld
         }
         else if (y >= minY && y < minY + type.getOceanY())
         {
-            return type.getOceanBlockId();
+            return type.getOceanBlockIds()[0];
         }
 
         return 0;
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
index f719594bc..e53cd9eee 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/overworld/hell/ChunkDecoratorOverworldHell.java
@@ -233,8 +233,8 @@ public class ChunkDecoratorOverworldHell
 
         final int minY = world.getWorldType().getMinY(world);
 
-        if (world.getBlockId(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ) == world.getWorldType().getOceanBlockId()) {
-            world.setBlockWithNotify(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ, world.getWorldType().getOceanBlockId());
+        if (world.getBlockId(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ) == world.getWorldType().getOceanBlockIds()[0]) {
+            world.setBlockWithNotify(worldX, minY + world.getWorldType().getOceanY() - 1, worldZ, world.getWorldType().getOceanBlockIds()[0]);
         }
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
index ba9b554b7..9581f8d1c 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/feature/WorldFeatureLabyrinth.java
@@ -121,16 +121,19 @@ public class WorldFeatureLabyrinth extends WorldFeature
         chestLoot.addEntry(new WeightedRandomLootObject(Items.HANDCANNON_UNLOADED.getDefaultStack()), 4.5);
 
         chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_HELMET_CHAINMAIL.getDefaultStack())
-                        .setRandomMetadata(Items.ARMOR_HELMET_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_HELMET_CHAINMAIL.getMaxDamage()), 20);
+            .setRandomMetadata(Items.ARMOR_HELMET_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_HELMET_CHAINMAIL.getMaxDamage()), 20);
 
         chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_CHESTPLATE_CHAINMAIL.getDefaultStack())
-                .setRandomMetadata(Items.ARMOR_CHESTPLATE_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_CHESTPLATE_CHAINMAIL.getMaxDamage()), 20);
+            .setRandomMetadata(Items.ARMOR_CHESTPLATE_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_CHESTPLATE_CHAINMAIL.getMaxDamage()), 20);
 
         chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_LEGGINGS_CHAINMAIL.getDefaultStack())
-                .setRandomMetadata(Items.ARMOR_LEGGINGS_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_LEGGINGS_CHAINMAIL.getMaxDamage()), 20);
+            .setRandomMetadata(Items.ARMOR_LEGGINGS_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_LEGGINGS_CHAINMAIL.getMaxDamage()), 20);
 
         chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_BOOTS_CHAINMAIL.getDefaultStack())
-                .setRandomMetadata(Items.ARMOR_BOOTS_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_BOOTS_CHAINMAIL.getMaxDamage()), 20);
+            .setRandomMetadata(Items.ARMOR_BOOTS_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_BOOTS_CHAINMAIL.getMaxDamage()), 20);
+
+        chestLoot.addEntry(new WeightedRandomLootObject(Items.ARMOR_WOLF_CHAINMAIL.getDefaultStack())
+            .setRandomMetadata(Items.ARMOR_WOLF_CHAINMAIL.getMaxDamage()/2, Items.ARMOR_WOLF_CHAINMAIL.getMaxDamage()), 20);
 
         chestLoot.addEntry(new WeightedRandomLootObject(Items.INGOT_STEEL_CRUDE.getDefaultStack()), 10);
         chestLoot.addEntry(new WeightedRandomLootObject(null), 892);
